/*!
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.8
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
"use strict";var strShimFunction="function",strShimObject="object",strShimUndefined="undefined",strShimPrototype="prototype",ObjClass$1=Object;function _pureAssign(e,t){return e||t}function _pureRef(e,t){return e[t]}var UNDEF_VALUE=undefined,NULL_VALUE=null,EMPTY="",FUNCTION="function",OBJECT="object",PROTOTYPE="prototype",__PROTO__="__proto__",UNDEFINED="undefined",CONSTRUCTOR="constructor",SYMBOL="Symbol",LENGTH="length",NAME="name",CALL="call",TO_STRING="toString",GET_OWN_PROPERTY_DESCRIPTOR="getOwnPropertyDescriptor",ObjClass=_pureAssign(Object),ObjProto=_pureRef(ObjClass,PROTOTYPE),StrCls=_pureAssign(String),StrProto=_pureRef(StrCls,PROTOTYPE),MathCls=_pureAssign(Math),ArrCls=_pureAssign(Array),ArrProto=_pureRef(ArrCls,PROTOTYPE),ArrSlice=_pureRef(ArrProto,"slice"),POLYFILL_TAG="_polyfill",POLYFILL_TYPE_NAME="__nw21$polytype__";function safe(e,t){try{return{v:e.apply(this,t)}}catch(n){return{e:n}}}function safeGet(e,t,n){e=safe(e,n);return e.e?t:e.v}function _createIs(t){return function(e){return typeof e===t}}function _createObjIs(e){var t="[object "+e+"]";return function(e){return!(!e||objToString(e)!==t)}}function objToString(e){return ObjProto[TO_STRING].call(e)}function isUndefined(e){return typeof e===UNDEFINED||e===UNDEFINED}function isStrictUndefined(e){return e===UNDEF_VALUE}function isNullOrUndefined(e){return e===NULL_VALUE||isUndefined(e)}function isStrictNullOrUndefined(e){return e===NULL_VALUE||e===UNDEF_VALUE}function isDefined(e){return!!e||e!==UNDEF_VALUE}var isString=_createIs("string"),isFunction=_createIs(FUNCTION);function isObject(e){return!(!e&&isNullOrUndefined(e)||!e||typeof e!==OBJECT)}var isArray=_pureRef(ArrCls,"isArray"),isError=_createObjIs("Error");function isTruthy(e){return!(!e||safeGet(function(){return!(e&&0+e)},!e))}function _returnNothing(){}function _returnFalse(){return!1}var asString=_pureAssign(StrCls),ERROR_TYPE="[object Error]";function dumpObj(e,t){var n=EMPTY,r=ObjProto[TO_STRING][CALL](e);r===ERROR_TYPE&&(e={stack:asString(e.stack),message:asString(e.message),name:asString(e.name)});try{n=((n=JSON.stringify(e,NULL_VALUE,t?"number"==typeof t?t:4:UNDEF_VALUE))?n.replace(/"(\w+)"\s*:\s{0,1}/g,"$1: "):NULL_VALUE)||asString(e)}catch(o){n=" - "+dumpObj(o,t)}return r+": "+n}function throwTypeError(e){throw new TypeError(e)}function _throwIfNullOrUndefined(e){isStrictNullOrUndefined(e)&&throwTypeError("Cannot convert undefined or null to object")}function _throwIfNotString(e){isString(e)||throwTypeError("'"+dumpObj(e)+"' is not a string")}function objHasOwnProperty(e,t){return!!e&&ObjProto.hasOwnProperty[CALL](e,t)}var _objGetOwnPropertyDescriptor$2=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),objHasOwn=_pureAssign(_pureRef(ObjClass,"hasOwn"),polyObjHasOwn);function polyObjHasOwn(e,t){return _throwIfNullOrUndefined(e),objHasOwnProperty(e,t)||!!_objGetOwnPropertyDescriptor$2(e,t)}function objForEachKey(e,t,n){if(e&&(isObject(e)||isFunction(e)))for(var r in e)if(objHasOwn(e,r)&&-1===t[CALL](n||e,r,e[r]))break}function arrForEach(e,t,n){if(e)for(var r=e[LENGTH]>>>0,o=0;o<r&&!(o in e&&-1===t[CALL](n||e,e[o],o,e));o++);}var _unwrapFunction=_unwrapFunctionWithPoly;function _unwrapFunctionWithPoly(r,e,o){var i=e?e[r]:NULL_VALUE;return function(e){var t,n=(e?e[r]:NULL_VALUE)||i;if(n||o)return t=arguments,(n||o).apply(e,n?ArrSlice[CALL](t,1):t);throwTypeError('"'+asString(r)+'" not defined for '+dumpObj(e))}}var _objGetOwnPropertyDescriptor$1=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),propMap={e:"enumerable",c:"configurable",v:"value",w:"writable",g:"get",s:"set"};function _createProp(t){var e,n={};return n[propMap.c]=!0,n[propMap.e]=!0,t.l&&(n.get=function(){return t.l.v},(e=_objGetOwnPropertyDescriptor$1(t.l,"v"))&&e.set&&(n.set=function(e){t.l.v=e})),objForEachKey(t,function(e,t){n[propMap[e]]=isStrictUndefined(t)?n[propMap[e]]:t}),n}var objDefineProp=_pureRef(ObjClass,"defineProperty"),objDefineProperties=_pureRef(ObjClass,"defineProperties");function objDefine(e,t,n){return objDefineProp(e,t,_createProp(n))}function _createKeyValueMap(e,n,r,t,o){var i={};return objForEachKey(e,function(e,t){_assignMapValue(i,e,n?t:e),_assignMapValue(i,t,r?t:e)}),t?t(i):i}function _assignMapValue(e,t,n,r){objDefineProp(e,t,{value:n,enumerable:!0,writable:!1})}var objIsFrozen=_pureAssign(_pureRef(ObjClass,"isFrozen"),_returnFalse),_objFreeze=_pureRef(ObjClass,"freeze");function _doNothing(e){return e}function _getProto(e){return _throwIfNullOrUndefined(e),e[__PROTO__]||NULL_VALUE}var objKeys=_pureRef(ObjClass,"keys");function _deepFreeze(e,n){if((isArray(e)||isObject(e)||isFunction(e))&&!objIsFrozen(e)){for(var t=0;t<n.length;t++)if(n[t]===e)return e;n.push(e),objForEachKey(e,function(e,t){_deepFreeze(t,n)}),objFreeze(e)}return e}function objDeepFreeze(e){return _objFreeze?_deepFreeze(e,[]):e}var objFreeze=_pureAssign(_objFreeze,_doNothing),objGetPrototypeOf=_pureAssign(_pureRef(ObjClass,"getPrototypeOf"),_getProto);function createEnum(e){return _createKeyValueMap(e,1,0,objFreeze)}function createEnumKeyMap(e){return _createKeyValueMap(e,0,0,objFreeze)}var _globalCfg,_wellKnownSymbolMap=createEnumKeyMap({asyncIterator:0,hasInstance:1,isConcatSpreadable:2,iterator:3,match:4,matchAll:5,replace:6,search:7,species:8,split:9,toPrimitive:10,toStringTag:11,unscopables:12}),GLOBAL_CONFIG_KEY="__tsUtils$gblCfg";function _getGlobalValue(){var e;return(e=(e=(e=typeof globalThis!==UNDEFINED?globalThis:e)||typeof self===UNDEFINED?e:self)||typeof window===UNDEFINED?e:window)||typeof global===UNDEFINED?e:global}function _getGlobalConfig(){var e;return _globalCfg||(e=safe(_getGlobalValue).v||{},_globalCfg=e[GLOBAL_CONFIG_KEY]=e[GLOBAL_CONFIG_KEY]||{}),_globalCfg}var mathMax=_pureRef(MathCls,"max"),strSlice=_unwrapFunctionWithPoly("slice",StrProto),strSubstring=_unwrapFunctionWithPoly("substring",StrProto),strSubstr=_unwrapFunctionWithPoly("substr",StrProto,polyStrSubstr);function polyStrSubstr(e,t,n){return _throwIfNullOrUndefined(e),n<0?EMPTY:((t=t||0)<0&&(t=mathMax(t+e[LENGTH],0)),isUndefined(n)?strSlice(e,t):strSlice(e,t,t+n))}function strLeft(e,t){return strSubstring(e,0,t)}function _tagAsPolyfill(e,t){return e&&(safe(function(){e[POLYFILL_TAG]=!0,e[POLYFILL_TYPE_NAME]=t}),safe(objDefine,[e,POLYFILL_TAG,{v:!0,w:!1,e:!1}]),safe(objDefine,[e,POLYFILL_TYPE_NAME,{v:t,w:!1,e:!1}])),e}var _globalLazyTestHooks,objCreate=_pureAssign(_pureRef(ObjClass,"create"),polyObjCreate);function polyObjCreate(e,t){var n;function r(){}return n=isStrictNullOrUndefined(e)?{}:((n=typeof e)!==OBJECT&&n!==FUNCTION&&throwTypeError("Prototype must be an Object or function: "+dumpObj(e)),r[PROTOTYPE]=e,safe(function(){r[__PROTO__]=e}),new r),t&&safe(objDefineProperties,[n,t]),n}function utcNow(){return(Date.now||polyUtcNow)()}function polyUtcNow(){return(new Date).getTime()}function fnApply(e,t,n){return e.apply(t,n)}function _initTestHooks(){_globalLazyTestHooks=_getGlobalConfig()}function getLazy(t,n){var r={};return _globalLazyTestHooks||_initTestHooks(),r.b=_globalLazyTestHooks.lzy,objDefineProp(r,"v",{configurable:!0,get:function(){var e=fnApply(t,null,n);return _globalLazyTestHooks.lzy||objDefineProp(r,"v",{value:e}),r.b=_globalLazyTestHooks.lzy,e}}),r}var _polySymbols,_wellKnownSymbolCache,mathRandom=_pureRef(MathCls,"random"),_uniqueInstanceId=getLazy(function(){for(var e=utcNow().toString(36).slice(2);e.length<16;)e+=mathRandom().toString(36).slice(2);return e.substring(0,16)}),UNIQUE_REGISTRY_ID="_urid",POLY_SYM="$nw21sym",_polyId=0;function _globalSymbolRegistry(){var e;return _polySymbols||(e=_getGlobalConfig(),_polySymbols=e.gblSym=e.gblSym||{k:{},s:{}}),_polySymbols}function polyNewSymbol(e){var t="_"+_polyId+++"_"+_uniqueInstanceId.v,n=SYMBOL+"("+e+")";function r(e,t){objDefine(o,e,{v:t,e:!1,w:!1})}var o=objCreate(null);return r("description",asString(e)),r(TO_STRING,function(){return n+POLY_SYM+t}),r("valueOf",function(){return o}),r("v",n),r("_uid",t),_tagAsPolyfill(o,"symbol")}function polySymbolFor(e){var t,n,r=_globalSymbolRegistry();return objHasOwn(r.k,e)||(t=polyNewSymbol(e),n=objKeys(r.s).length,t[UNIQUE_REGISTRY_ID]=function(){return n+"_"+t[TO_STRING]()},r.k[e]=t,r.s[t[UNIQUE_REGISTRY_ID]()]=asString(e)),r.k[e]}function polyGetKnownSymbol(e){_wellKnownSymbolCache=_wellKnownSymbolCache||{};e=_wellKnownSymbolMap[e];return e?_wellKnownSymbolCache[e]=_wellKnownSymbolCache[e]||polyNewSymbol(SYMBOL+"."+e):void 0}function createCachedValue(e){return objDefineProp({toJSON:function(){return e}},"v",{value:e})}var _cachedGlobal,WINDOW="window";function _getGlobalInstFn(e,t){var n;return function(){return _globalLazyTestHooks||_initTestHooks(),(n=n&&!_globalLazyTestHooks.lzy?n:createCachedValue(safe(e,t).v)).v}}function getGlobal(e){return _globalLazyTestHooks||_initTestHooks(),(_cachedGlobal=_cachedGlobal&&!1!==e&&!_globalLazyTestHooks.lzy?_cachedGlobal:createCachedValue(safe(_getGlobalValue).v||NULL_VALUE)).v}function getInst(e,t){t=_cachedGlobal&&!1!==t?_cachedGlobal.v:getGlobal(t);if(t&&t[e])return t[e];if(e===WINDOW)try{return window}catch(n){}return NULL_VALUE}var getDocument=_getGlobalInstFn(getInst,["document"]);function hasWindow(){return!!getWindow()}var _symbol,_symbolFor,_iterSymbol$1,getWindow=_getGlobalInstFn(getInst,[WINDOW]),getNavigator=_getGlobalInstFn(getInst,["navigator"]);function _initSymbol(){return _symbol=createCachedValue(safe(getInst,[SYMBOL]).v)}function _getSymbolKey(e){var t=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return t.v?t.v[e]:UNDEF_VALUE}function getKnownSymbol(e,t){var n=_wellKnownSymbolMap[e],r=(_globalLazyTestHooks||_initTestHooks(),(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol());return r.v?r.v[n||e]:t?UNDEF_VALUE:polyGetKnownSymbol(e)}function newSymbol(e,t){_globalLazyTestHooks||_initTestHooks();var n=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return n.v?n.v(e):t?NULL_VALUE:polyNewSymbol(e)}function symbolFor(e){return _globalLazyTestHooks||_initTestHooks(),((_symbolFor=(_globalLazyTestHooks.lzy?0:_symbolFor)||createCachedValue(safe(_getSymbolKey,["for"]).v)).v||polySymbolFor)(e)}function isIterator(e){return!!e&&isFunction(e.next)}function isIterable(e){return!isStrictNullOrUndefined(e)&&isFunction(e[getKnownSymbol(3)])}function iterForOf(e,t,n){if(e&&(isIterator(e)||(e=e[(_iterSymbol$1=_iterSymbol$1||createCachedValue(getKnownSymbol(3))).v]?e[_iterSymbol$1.v]():NULL_VALUE),isIterator(e))){var r=UNDEF_VALUE,o=UNDEF_VALUE;try{for(var i=0;!(o=e.next()).done&&-1!==t[CALL](n||e,o.value,i,e);)i++}catch(a){r={e:a},e["throw"]&&(o=NULL_VALUE,e["throw"](r))}finally{try{o&&!o.done&&e["return"]&&e["return"](o)}finally{if(r)throw r.e}}}}function arrAppend(t,e){return!isUndefined(e)&&t&&(isArray(e)?fnApply(t.push,t,e):isIterator(e)||isIterable(e)?iterForOf(e,function(e){t.push(e)}):t.push(e)),t}var _isProtoArray,arrIndexOf=_unwrapFunctionWithPoly("indexOf",ArrProto),objSetPrototypeOf=_pureAssign(_pureRef(ObjClass,"setPrototypeOf"),_polyObjSetPrototypeOf);function _polyObjSetPrototypeOf(n,e){var t;return(_isProtoArray=_isProtoArray||createCachedValue(((t={})[__PROTO__]=[],t instanceof Array))).v?n[__PROTO__]=e:objForEachKey(e,function(e,t){return n[e]=t}),n}function _createCustomError(e,t,n){function r(){this[CONSTRUCTOR]=t,safe(objDefine,[this,NAME,{v:e,c:!0,e:!1}])}return safe(objDefine,[t,NAME,{v:e,c:!0,e:!1}]),(t=objSetPrototypeOf(t,n))[PROTOTYPE]=n===NULL_VALUE?objCreate(n):(r[PROTOTYPE]=n[PROTOTYPE],new r),t}function _setName(e,t){t&&(e[NAME]=t)}function createCustomError(o,i,e){var a=e||Error,_=a[PROTOTYPE][NAME],s=Error.captureStackTrace;return _createCustomError(o,function(){var e=this,t=arguments;try{safe(_setName,[a,o]);var n,r=fnApply(a,e,ArrSlice[CALL](t))||e;return r!==e&&(n=objGetPrototypeOf(e))!==objGetPrototypeOf(r)&&objSetPrototypeOf(r,n),s&&s(r,e[CONSTRUCTOR]),i&&i(r,t),r}finally{safe(_setName,[a,_])}},a)}function _createTrimFn(t){return function(e){return _throwIfNullOrUndefined(e),e&&e.replace?e.replace(t,EMPTY):e}}var _fnToString,_objCtrFnString,_gblWindow,polyStrTrim=_createTrimFn(/^\s+|(?=\s)\s+$/g),strTrim=_unwrapFunctionWithPoly("trim",StrProto,polyStrTrim),mathFloor=_pureRef(MathCls,"floor");function isPlainObject(e){if(!e||typeof e!==OBJECT)return!1;var t=!1;if(e!==(_gblWindow=_gblWindow||!hasWindow()||getWindow())){_objCtrFnString||(_fnToString=Function[PROTOTYPE][TO_STRING],_objCtrFnString=_fnToString[CALL](ObjClass));try{var n=objGetPrototypeOf(e),t=(t=!n)||!(!(n=objHasOwnProperty(n,CONSTRUCTOR)?n[CONSTRUCTOR]:n)||typeof n!==FUNCTION||_fnToString[CALL](n)!==_objCtrFnString)}catch(r){}}return t}var mathRound=_pureRef(MathCls,"round"),objGetOwnPropertyDescriptor=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),strEndsWith=_unwrapFunctionWithPoly("endsWith",StrProto,polyStrEndsWith);function polyStrEndsWith(e,t,n){_throwIfNotString(e);t=isString(t)?t:asString(t),n=!isUndefined(n)&&n<e[LENGTH]?n:e[LENGTH];return strSubstring(e,n-t[LENGTH],n)===t}var _setTimeoutFn,_clearTimeoutFn,strIndexOf=_unwrapFunctionWithPoly("indexOf",StrProto),REF="ref",UNREF="unref",HAS_REF="hasRef",ENABLED="enabled";function _createTimerHandler(e,t,n){var r,o=!0,i=e?t(NULL_VALUE):NULL_VALUE;function a(){return o=!1,i&&i[UNREF]&&i[UNREF](),r}function _(){i&&n(i),i=NULL_VALUE}function s(){return i=t(i),o||a(),r}return(r={cancel:_,refresh:s})[HAS_REF]=function(){return i&&i[HAS_REF]?i[HAS_REF]():o},r[REF]=function(){return o=!0,i&&i[REF]&&i[REF](),r},r[UNREF]=a,{h:r=objDefineProp(r,ENABLED,{get:function(){return!!i},set:function(e){!e&&i&&_(),e&&!i&&s()}}),dn:function(){i=NULL_VALUE}}}function _resolveTimeoutFn(e){var t,e=isFunction(e)?e:_setTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&0<t.length&&isFunction(t[0])&&(e=t[0])),e||setTimeout}function _resolveClearTimeoutFn(e){var t,e=isFunction(e)?e:_clearTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&1<t.length&&isFunction(t[1])&&(e=t[1])),e||clearTimeout}function _createTimeoutWith(e,t,n){var r=isArray(t),o=r?t.length:0,i=_resolveTimeoutFn(0<o?t[0]:r?UNDEF_VALUE:t),a=_resolveClearTimeoutFn(1<o?t[1]:UNDEF_VALUE),_=n[0],s=(n[0]=function(){s.dn(),fnApply(_,UNDEF_VALUE,ArrSlice[CALL](arguments))},_createTimerHandler(e,function(e){if(e){if(e.refresh)return e.refresh(),e;fnApply(a,UNDEF_VALUE,[e])}return fnApply(i,UNDEF_VALUE,n)},function(e){fnApply(a,UNDEF_VALUE,[e])}));return s.h}function scheduleTimeout(e,t){return _createTimeoutWith(!0,UNDEF_VALUE,ArrSlice[CALL](arguments))}(getGlobal()||{}).Symbol,(getGlobal()||{}).Reflect;var _a$4,strHasOwnProperty="hasOwnProperty",extendStaticsFn=function(e,t){return(extendStaticsFn=ObjClass$1.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t[strHasOwnProperty](n)&&(e[n]=t[n])})(e,t)};function __extendsFn(e,t){function n(){this.constructor=e}typeof t!==strShimFunction&&null!==t&&throwTypeError("Class extends value "+t+" is not a constructor or null"),extendStaticsFn(e,t),e[strShimPrototype]=null===t?objCreate(t):(n[strShimPrototype]=t[strShimPrototype],new n)}var Constructor="constructor",Prototype="prototype",strFunction="function",DynInstFuncTable="_dynInstFuncs",DynProxyTag="_isDynProxy",DynClassName="_dynClass",DynClassNamePrefix="_dynCls$",DynInstChkTag="_dynInstChk",DynAllowInstChkTag=DynInstChkTag,DynProtoDefaultOptions="_dfOpts",UnknownValue="_unknown_",str__Proto="__proto__",DynProtoBaseProto="_dyn"+str__Proto,DynProtoGlobalSettings="__dynProto$Gbl",DynProtoCurrent="_dynInstProto",strUseBaseInst="useBaseInst",strSetInstFuncs="setInstFuncs",Obj=Object,_objGetPrototypeOf=Obj.getPrototypeOf,_objGetOwnProps=Obj.getOwnPropertyNames,_gbl=getGlobal(),_gblInst=_gbl[DynProtoGlobalSettings]||(_gbl[DynProtoGlobalSettings]={o:((_a$4={})[strSetInstFuncs]=!0,_a$4[strUseBaseInst]=!0,_a$4),n:1e3});function _isObjectOrArrayPrototype(e){return e&&(e===Obj[Prototype]||e===Array[Prototype])}function _isObjectArrayOrFunctionPrototype(e){return _isObjectOrArrayPrototype(e)||e===Function[Prototype]}function _getObjProto(e){if(e){if(_objGetPrototypeOf)return _objGetPrototypeOf(e);var t=e[str__Proto]||e[Prototype]||(e[Constructor]?e[Constructor][Prototype]:null),n=e[DynProtoBaseProto]||t;objHasOwnProperty(e,DynProtoBaseProto)||(delete e[DynProtoCurrent],n=e[DynProtoBaseProto]=e[DynProtoCurrent]||e[DynProtoBaseProto],e[DynProtoCurrent]=t)}return n}function _forEachProp(e,t){var n=[];if(_objGetOwnProps)n=_objGetOwnProps(e);else for(var r in e)"string"==typeof r&&objHasOwnProperty(e,r)&&n.push(r);if(n&&0<n.length)for(var o=0;o<n.length;o++)t(n[o])}function _isDynamicCandidate(e,t,n){return t!==Constructor&&typeof e[t]===strFunction&&(n||objHasOwnProperty(e,t))&&t!==str__Proto&&t!==Prototype}function _throwTypeError(e){throwTypeError("DynamicProto: "+e)}function _getInstanceFuncs(t){var n=objCreate(null);return _forEachProp(t,function(e){!n[e]&&_isDynamicCandidate(t,e,!1)&&(n[e]=t[e])}),n}function _hasVisited(e,t){for(var n=e.length-1;0<=n;n--)if(e[n]===t)return!0;return!1}function _getBaseFuncs(e,t,n,i){function r(e,t,n){var r,o=t[n];return o[DynProxyTag]&&i&&!1!==(r=e[DynInstFuncTable]||{})[DynAllowInstChkTag]&&(o=(r[t[DynClassName]]||{})[n]||o),function(){return o.apply(e,arguments)}}for(var o=objCreate(null),a=(_forEachProp(n,function(e){o[e]=r(t,n,e)}),_getObjProto(e)),_=[];a&&!_isObjectArrayOrFunctionPrototype(a)&&!_hasVisited(_,a);)_forEachProp(a,function(e){!o[e]&&_isDynamicCandidate(a,e,!_objGetPrototypeOf)&&(o[e]=r(t,a,e))}),_.push(a),a=_getObjProto(a);return o}function _getInstFunc(e,t,n,r){var o=null;if(e&&objHasOwnProperty(n,DynClassName)){var i=e[DynInstFuncTable]||objCreate(null);if((o=(i[n[DynClassName]]||objCreate(null))[t])||_throwTypeError("Missing ["+t+"] "+strFunction),!o[DynInstChkTag]&&!1!==i[DynAllowInstChkTag]){for(var a=!objHasOwnProperty(e,t),_=_getObjProto(e),s=[];a&&_&&!_isObjectArrayOrFunctionPrototype(_)&&!_hasVisited(s,_);){var u=_[t];if(u){a=u===r;break}s.push(_),_=_getObjProto(_)}try{a&&(e[t]=o),o[DynInstChkTag]=1}catch(c){i[DynAllowInstChkTag]=!1}}}return o}function _getProtoFunc(e,t,n){var r=t[e];return typeof(r=r===n?_getObjProto(t)[e]:r)!==strFunction&&_throwTypeError("["+e+"] is not a "+strFunction),r}function _populatePrototype(o,e,i,a,t){var n,_;_isObjectOrArrayPrototype(o)||_isObjectOrArrayPrototype(n=i[DynInstFuncTable]=i[DynInstFuncTable]||objCreate(null))||(_=n[e]=n[e]||objCreate(null),!1!==n[DynAllowInstChkTag]&&(n[DynAllowInstChkTag]=!!t),_isObjectOrArrayPrototype(_)||_forEachProp(i,function(e){var t,n,r;_isDynamicCandidate(i,e,!1)&&i[e]!==a[e]&&(_[e]=i[e],delete i[e],objHasOwnProperty(o,e)&&(!o[e]||o[e][DynProxyTag])||(o[e]=(t=o,n=e,(r=function(){return(_getInstFunc(this,n,t,r)||_getProtoFunc(n,t,r)).apply(this,arguments)})[DynProxyTag]=1,r)))}))}function _checkPrototype(e,t){if(_objGetPrototypeOf){for(var n=[],r=_getObjProto(t);r&&!_isObjectArrayOrFunctionPrototype(r)&&!_hasVisited(n,r);){if(r===e)return!0;n.push(r),r=_getObjProto(r)}return!1}return!0}function _getObjName(e,t){return objHasOwnProperty(e,Prototype)?e.name||t||UnknownValue:((e||{})[Constructor]||{}).name||t||UnknownValue}function dynamicProto(e,t,n,r){objHasOwnProperty(e,Prototype)||_throwTypeError("theClass is an invalid class definition.");var o=e[Prototype],i=(_checkPrototype(o,t)||_throwTypeError("["+_getObjName(e)+"] not in hierarchy of ["+_getObjName(t)+"]"),null),e=(objHasOwnProperty(o,DynClassName)?i=o[DynClassName]:(i=DynClassNamePrefix+_getObjName(e,"_")+"$"+_gblInst.n,_gblInst.n++,o[DynClassName]=i),dynamicProto[DynProtoDefaultOptions]),a=!!e[strUseBaseInst],_=(a&&r&&r[strUseBaseInst]!==undefined&&(a=!!r[strUseBaseInst]),_getInstanceFuncs(t)),a=(n(t,_getBaseFuncs(o,t,_,a)),!!_objGetPrototypeOf&&!!e[strSetInstFuncs]);_populatePrototype(o,i,t,_,!1!==(a=a&&r?!!r[strSetInstFuncs]:a))}dynamicProto[DynProtoDefaultOptions]=_gblInst.o;var aggregationErrorType,createEnumStyle=createEnum,_DYN_TO_LOWER_CASE="toLowerCase",_DYN_LENGTH$1="length",_DYN_WARN_TO_CONSOLE="warnToConsole",_DYN_THROW_INTERNAL="throwInternal",_DYN_WATCH="watch",_DYN_APPLY="apply",_DYN_PUSH="push",_DYN_SPLICE="splice",_DYN_LOGGER="logger",_DYN_CANCEL="cancel",_DYN_INITIALIZE="initialize",_DYN_IDENTIFIER="identifier",_DYN_IS_INITIALIZED="isInitialized",_DYN_GET_PLUGIN="getPlugin",_DYN_NAME$1="name",_DYN_PROCESS_NEXT="processNext",_DYN_GET_PROCESS_TEL_CONT2="getProcessTelContext",_DYN_ENABLED="enabled",_DYN_UNLOAD="unload",_DYN_LOGGING_LEVEL_CONSOL4="loggingLevelConsole",_DYN_CREATE_NEW="createNew",_DYN_TEARDOWN="teardown",_DYN_MESSAGE_ID="messageId",_DYN_MESSAGE="message",_DYN_DIAG_LOG="diagLog",_DYN__DO_TEARDOWN="_doTeardown",_DYN_UPDATE="update",_DYN_GET_NEXT="getNext",_DYN_SET_NEXT_PLUGIN="setNextPlugin",_DYN_USER_AGENT="userAgent",_DYN_SPLIT="split",_DYN_REPLACE="replace",_DYN_IS_CHILD_EVT="isChildEvt",_DYN_GET_CTX="getCtx",_DYN_SET_CTX="setCtx";function throwAggregationError(e,t){aggregationErrorType=aggregationErrorType||createCustomError("AggregationError",function(e,t){1<t[_DYN_LENGTH$1]&&(e.errors=t[1])});var n=e||"One or more errors occurred.";throw arrForEach(t,function(e,t){n+="\n".concat(t," > ").concat(dumpObj(e))}),new aggregationErrorType(n,t||[])}var UNDEFINED_VALUE=undefined,STR_EMPTY="",STR_CORE="core",STR_DISABLED="disabled",STR_EXTENSION_CONFIG="extensionConfig",STR_PROCESS_TELEMETRY="processTelemetry",STR_PRIORITY="priority",STR_GET_PERF_MGR="getPerfMgr",STR_DOMAIN="domain",STR_PATH="path",STR_NOT_DYNAMIC_ERROR="Not dynamic - ",rCamelCase=/-([a-z])/g,rNormalizeInvalid=/([^\w\d_$])/g,rLeadingNumeric=/^(\d+[\w\d_$])/;function isNotNullOrUndefined(e){return!isNullOrUndefined(e)}function normalizeJsName(e){return e&&isString(e)?(e=(e=e[_DYN_REPLACE](rCamelCase,function(e,t){return t.toUpperCase()}))[_DYN_REPLACE](rNormalizeInvalid,"_"))[_DYN_REPLACE](rLeadingNumeric,function(e,t){return"_"+t}):e}function strContains(e,t){return!(!e||!t)&&-1!==strIndexOf(e,t)}function toISOString(e){return e&&e.toISOString()||""}function getExceptionName(e){return isError(e)?e[_DYN_NAME$1]:STR_EMPTY}function setValue(e,t,n,r,o){var i=n;return!e||(i=e[t])===n||o&&!o(i)||r&&!r(n)||(e[t]=i=n),i}function getSetValue(e,t,n){var r;return e?!(r=e[t])&&isNullOrUndefined(r)&&(r=isUndefined(n)?{}:n,e[t]=r):r=isUndefined(n)?{}:n,r}function _createProxyFunction(e,t){var n=null,r=null;return isFunction(e)?n=e:r=e,function(){var e=arguments;if(r=n?n():r)return r[t][_DYN_APPLY](r,e)}}function proxyFunctionAs(e,t,n,r,o){e&&t&&n&&(!1===o&&!isUndefined(e[t])||(e[t]=_createProxyFunction(n,r)))}function createClassFromInterface(e){return function(){var n=this;e&&objForEachKey(e,function(e,t){n[e]=t})}}var strLocation="location",strConsole="console",strJSON="JSON",strCrypto="crypto",strMsCrypto="msCrypto",strMsie="msie",strTrident="trident/",_isTrident=null,_navUserAgentCheck=null,_enableMocks=!1;function getLocation(e){if(e&&_enableMocks){e=getInst("__mockLocation");if(e)return e}return typeof location===strShimObject&&location?location:getInst(strLocation)}function getConsole(){return typeof console!==strShimUndefined?console:getInst(strConsole)}function hasJSON(){return!!(typeof JSON===strShimObject&&JSON||null!==getInst(strJSON))}function getJSON(){return hasJSON()?JSON||getInst(strJSON):null}function getCrypto(){return getInst(strCrypto)}function getMsCrypto(){return getInst(strMsCrypto)}function isIE(){var e=getNavigator();return!e||e[_DYN_USER_AGENT]===_navUserAgentCheck&&null!==_isTrident||(e=((_navUserAgentCheck=e[_DYN_USER_AGENT])||STR_EMPTY)[_DYN_TO_LOWER_CASE](),_isTrident=strContains(e,strMsie)||strContains(e,strTrident)),_isTrident}var UInt32Mask=4294967296,MaxUInt32=4294967295,SEED1=123456789,SEED2=987654321,_mwcSeeded=!1,_mwcW=SEED1,_mwcZ=SEED2;function _mwcSeed(e){e<0&&(e>>>=0),_mwcW=SEED1+e&MaxUInt32,_mwcZ=SEED2-e&MaxUInt32,_mwcSeeded=!0}function _autoSeedMwc(){try{var e=2147483647&utcNow();_mwcSeed((Math.random()*UInt32Mask^e)+e)}catch(t){}}function random32(e){var t=0,n=getCrypto()||getMsCrypto();return 0===(t=n&&n.getRandomValues?n.getRandomValues(new Uint32Array(1))[0]&MaxUInt32:t)&&isIE()&&(_mwcSeeded||_autoSeedMwc(),t=mwcRandom32()&MaxUInt32),0===t&&(t=mathFloor(UInt32Mask*Math.random()|0)),e||(t>>>=0),t}function mwcRandom32(e){var t=((_mwcZ=36969*(65535&_mwcZ)+(_mwcZ>>16)&MaxUInt32)<<16)+(65535&(_mwcW=18e3*(65535&_mwcW)+(_mwcW>>16)&MaxUInt32))>>>0&MaxUInt32|0;return e||(t>>>=0),t}function newId(e){void 0===e&&(e=22);for(var t=random32()>>>0,n=0,r=STR_EMPTY;r[_DYN_LENGTH$1]<e;)r+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[0|63&t]||"",t>>>=6,5==++n&&(t=(random32()<<2&4294967295|3&t)>>>0,n=0);return r}var version="3.3.8",instanceName="."+newId(6),_dataUid=0;function _canAcceptData(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType}function _getCache(e,t){var n=t[e.id];if(!n){n={};try{_canAcceptData(t)&&objDefine(t,e.id,{e:!1,v:n})}catch(r){}}return n}function createUniqueNamespace(e,t){return normalizeJsName(e+_dataUid+++((t=void 0!==t&&t)?"."+version:STR_EMPTY)+instanceName)}function createElmNodeData(e){var i={id:createUniqueNamespace("_aiData-"+(e||STR_EMPTY)+"."+version),accept:function(e){return _canAcceptData(e)},get:function(e,t,n,r){var o=e[i.id];return o?o[normalizeJsName(t)]:(r&&((o=_getCache(i,e))[normalizeJsName(t)]=n),n)},kill:function(e,t){if(e&&e[t])try{delete e[t]}catch(n){}}};return i}function _isConfigDefaults(e){return e&&isObject(e)&&!isArray(e)&&(e.isVal||e.fb||objHasOwn(e,"v")||objHasOwn(e,"mrg")||objHasOwn(e,"ref")||e.set)}function _getDefault(e,t,n){var r,o=n.dfVal||isDefined;if(t&&n.fb){var i=n.fb;isArray(i)||(i=[i]);for(var a=0;a<i[_DYN_LENGTH$1];a++){var _=i[a],s=t[_];if(o(s)?r=s:e&&(o(s=e.cfg[_])&&(r=s),e.set(e.cfg,asString(_),s)),o(r))break}}return!o(r)&&o(n.v)?n.v:r}function _resolveDefaultValue(n,r,e){var o,t=e;return(t=e&&_isConfigDefaults(e)?_getDefault(n,r,e):t)&&(_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),isArray(t)?(o=[])[_DYN_LENGTH$1]=t[_DYN_LENGTH$1]:isPlainObject(t)&&(o={}),o&&(objForEachKey(t,function(e,t){t&&_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),o[e]=t}),t=o)),t}function _applyDefaultValue(n,e,t,r){var o,i,a,_,s,u,c=r,c=_isConfigDefaults(c)?(o=c.isVal,i=c.set,s=c.rdOnly,l=c.blkVal,a=c.mrg,!(_=c.ref)&&isUndefined(_)&&(_=!!a),_getDefault(n,e,c)):r,r=(l&&n.blkVal(e,t),!0),l=e[t];!l&&isNullOrUndefined(l)||(u=l,r=!1,o&&u!==c&&!o(u)&&(u=c,r=!0),i&&(r=(u=i(u,c,e))===c)),r?u=c&&_resolveDefaultValue(n,e,c):(isPlainObject(u)||isArray(c))&&a&&c&&(isPlainObject(c)||isArray(c))&&objForEachKey(c,function(e,t){_applyDefaultValue(n,u,e,t)}),n.set(e,t,u),_&&n.ref(e,t),s&&n.rdOnly(e,t)}var CFG_HANDLER_LINK=symbolFor("[[ai_dynCfg_1]]"),BLOCK_DYNAMIC=symbolFor("[[ai_blkDynCfg_1]]"),FORCE_DYNAMIC=symbolFor("[[ai_frcDynCfg_1]]");function _cfgDeepCopy(e){var n;return e&&(isArray(e)?(n=[])[_DYN_LENGTH$1]=e[_DYN_LENGTH$1]:isPlainObject(e)&&(n={}),n)?(objForEachKey(e,function(e,t){n[e]=_cfgDeepCopy(t)}),n):e}function getDynamicConfigHandler(e){if(e){var t=e[CFG_HANDLER_LINK]||e;if(t.cfg&&(t.cfg===e||t.cfg[CFG_HANDLER_LINK]===t))return t}return null}function blockDynamicConversion(e){if(e&&(isPlainObject(e)||isArray(e)))try{e[BLOCK_DYNAMIC]=!0}catch(t){}return e}function _canMakeDynamic(e,t,n){var r=!1;return!n||e[t.blkVal]||(r=n[FORCE_DYNAMIC])||n[BLOCK_DYNAMIC]?r:isPlainObject(n)||isArray(n)}function throwInvalidAccess(e){throwTypeError("InvalidAccess:"+e)}var arrayMethodsToPatch=["push","pop","shift","unshift","splice"],_throwDynamicError=function(e,t,n,r){e&&e[_DYN_THROW_INTERNAL](3,108,"".concat(n," [").concat(t,"] failed - ")+dumpObj(r))};function _patchArray(o,i,a){isArray(i)&&arrForEach(arrayMethodsToPatch,function(e){var r=i[e];i[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=r[_DYN_APPLY](this,e);return _makeDynamicObject(o,i,a,"Patching"),n}})}function _getOwnPropGetter(e,t){e=objGetOwnPropertyDescriptor(e,t);return e&&e.get}function _createDynamicProperty(o,i,a,_){var s={n:a,h:[],trk:function(e){e&&e.fn&&(-1===arrIndexOf(s.h,e)&&s.h[_DYN_PUSH](e),o.trk(e,s))},clr:function(e){e=arrIndexOf(s.h,e);-1!==e&&s.h[_DYN_SPLICE](e,1)}},u=!0,c=!1;function l(){u&&(c=c||_canMakeDynamic(l,o,_),_&&!_[CFG_HANDLER_LINK]&&c&&(_=_makeDynamicObject(o,_,a,"Converting")),u=!1);var e=o.act;return e&&s.trk(e),_}l[o.prop]={chng:function(){o.add(s)}},objDefine(i,s.n,{g:l,s:function(t){if(_!==t){l[o.ro]&&!o.upd&&throwInvalidAccess("["+a+"] is read-only:"+dumpObj(i)),u&&(c=c||_canMakeDynamic(l,o,_),u=!1);var e,n=c&&l[o.rf];if(c)if(n){objForEachKey(_,function(e){_[e]=t?t[e]:UNDEFINED_VALUE});try{objForEachKey(t,function(e,t){_setDynamicProperty(o,_,e,t)}),t=_}catch(r){_throwDynamicError((o.hdlr||{})[_DYN_LOGGER],a,"Assigning",r),c=!1}}else _&&_[CFG_HANDLER_LINK]&&objForEachKey(_,function(e){var e=_getOwnPropGetter(_,e);e&&(e=e[o.prop])&&e.chng()});t!==_&&(e=t&&_canMakeDynamic(l,o,t),!n&&e&&(t=_makeDynamicObject(o,t,a,"Converting")),_=t,c=e),o.add(s)}}})}function _setDynamicProperty(e,t,n,r){var o;return t&&((o=_getOwnPropGetter(t,n))&&o[e.prop]?t[n]=r:_createDynamicProperty(e,t,n,r)),t}function _setDynamicPropertyState(e,t,n,r){if(t){var o=_getOwnPropGetter(t,n),i=o&&!!o[e.prop],a=r&&r[0],_=r&&r[1],r=r&&r[2];if(!i){if(r)try{blockDynamicConversion(t)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"Blocking",s)}try{_setDynamicProperty(e,t,n,t[n]),o=_getOwnPropGetter(t,n)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"State",s)}}a&&(o[e.rf]=a),_&&(o[e.ro]=_),r&&(o[e.blkVal]=!0)}return t}function _makeDynamicObject(n,r,e,t){try{objForEachKey(r,function(e,t){_setDynamicProperty(n,r,e,t)}),r[CFG_HANDLER_LINK]||(objDefineProp(r,CFG_HANDLER_LINK,{get:function(){return n.hdlr}}),_patchArray(n,r,e))}catch(o){_throwDynamicError((n.hdlr||{})[_DYN_LOGGER],e,t,o)}return r}var symPrefix="[[ai_",symPostfix="]]";function _createState(i){var a,e=newSymbol(symPrefix+"get"+i.uid+symPostfix),t=newSymbol(symPrefix+"ro"+i.uid+symPostfix),n=newSymbol(symPrefix+"rf"+i.uid+symPostfix),r=newSymbol(symPrefix+"blkVal"+i.uid+symPostfix),_=newSymbol(symPrefix+"dtl"+i.uid+symPostfix),o=null,s=null;function u(t,e){var n=a.act;try{(a.act=t)&&t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=[]),e({cfg:i.cfg,set:i.set.bind(i),setDf:i.setDf.bind(i),ref:i.ref.bind(i),rdOnly:i.rdOnly.bind(i)})}catch(o){var r=i[_DYN_LOGGER];throw r&&r[_DYN_THROW_INTERNAL](1,107,dumpObj(o)),o}finally{a.act=n||null}}function c(){if(o){var e=o,n=(o=null,s&&s[_DYN_CANCEL](),s=null,[]);if(arrForEach(e,function(t){if(t&&(t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=null),t.fn))try{u(t,t.fn)}catch(e){n[_DYN_PUSH](e)}}),o)try{c()}catch(t){n[_DYN_PUSH](t)}0<n[_DYN_LENGTH$1]&&throwAggregationError("Watcher error(s): ",n)}}return a={prop:e,ro:t,rf:n,blkVal:r,hdlr:i,add:function(e){if(e&&0<e.h[_DYN_LENGTH$1]){o=o||[],s=s||scheduleTimeout(function(){s=null,c()},0);for(var t=0;t<e.h[_DYN_LENGTH$1];t++){var n=e.h[t];n&&-1===arrIndexOf(o,n)&&o[_DYN_PUSH](n)}}},notify:c,use:u,trk:function(e,t){e&&(e=e[_]=e[_]||[],-1===arrIndexOf(e,t)&&e[_DYN_PUSH](t))}}}function _createAndUseHandler(e,t){var n={fn:t,rm:function(){n.fn=null,t=e=null}};return objDefine(n,"toJSON",{v:function(){return"WatcherHandler"+(n.fn?"":"[X]")}}),e.use(n,t),n}function _createDynamicHandler(o,e,t){var n=getDynamicConfigHandler(e);if(n)return n;var i,n=createUniqueNamespace("dyncfg",!0),t=e&&!1!==t?e:_cfgDeepCopy(e),r={uid:null,cfg:t,logger:o,notify:function(){i.notify()},set:function(e,t,n){try{e=_setDynamicProperty(i,e,t,n)}catch(r){_throwDynamicError(o,t,"Setting value",r)}return e[t]},setDf:function(n,e){return e&&objForEachKey(e,function(e,t){_applyDefaultValue(r,n,e,t)}),n},watch:function(e){return _createAndUseHandler(i,e)},ref:function(e,t){return _setDynamicPropertyState(i,e,t,((e={})[0]=!0,e))[t]},rdOnly:function(e,t){return _setDynamicPropertyState(i,e,t,((e={})[1]=!0,e))[t]},blkVal:function(e,t){return _setDynamicPropertyState(i,e,t,((e={})[2]=!0,e))[t]},_block:function(n,r){i.use(null,function(e){var t=i.upd;try{isUndefined(r)||(i.upd=r),n(e)}finally{i.upd=t}})}};return objDefine(r,"uid",{c:!1,e:!1,w:!1,v:n}),_makeDynamicObject(i=_createState(r),t,"config","Creating"),r}function _logInvalidAccess(e,t){e?(e[_DYN_WARN_TO_CONSOLE](t),e[_DYN_THROW_INTERNAL](2,108,t)):throwInvalidAccess(t)}function createDynamicConfig(e,t,n,r){n=_createDynamicHandler(n,e||{},r);return t&&n.setDf(n.cfg,t),n}function onConfigChange(e,t,n){var r=e[CFG_HANDLER_LINK]||e;return!r.cfg||r.cfg!==e&&r.cfg[CFG_HANDLER_LINK]!==r?(_logInvalidAccess(n,STR_NOT_DYNAMIC_ERROR+dumpObj(e)),createDynamicConfig(e,null,n)[_DYN_WATCH](t)):r[_DYN_WATCH](t)}function cfgDfMerge(e){return{mrg:!0,v:e}}var _a$3,_aiNamespace=null;function _getExtensionNamespace(){var e=getInst("Microsoft");return _aiNamespace=e?e.ApplicationInsights:_aiNamespace}function getDebugExt(e){var t=_aiNamespace;return(t=t||!0===e.disableDbgExt?t:_aiNamespace||_getExtensionNamespace())?t.ChromeDbgExt:null}var STR_WARN_TO_CONSOLE="warnToConsole",AiNonUserActionablePrefix="AI (Internal): ",AiUserActionablePrefix="AI: ",AIInternalMessagePrefix="AITR_",defaultValues$1={loggingLevelConsole:0,loggingLevelTelemetry:1,maxMessageLimit:25,enableDebug:!1},_logFuncs=((_a$3={})[0]=null,_a$3[1]="errorToConsole",_a$3[2]=STR_WARN_TO_CONSOLE,_a$3[3]="debugToConsole",_a$3);function _sanitizeDiagnosticText(e){return e?'"'+e[_DYN_REPLACE](/\"/g,STR_EMPTY)+'"':STR_EMPTY}function _logToConsole(e,t){var n,r=getConsole();r&&(n="log",r[e]&&(n=e),isFunction(r[n])&&r[n](t))}var _InternalLogMessage=function(){function e(e,t,n,r){void 0===n&&(n=!1),this[_DYN_MESSAGE_ID]=e,this[_DYN_MESSAGE]=(n?AiUserActionablePrefix:AiNonUserActionablePrefix)+e;n=STR_EMPTY,hasJSON()&&(n=getJSON().stringify(r)),e=(t?" message:"+_sanitizeDiagnosticText(t):STR_EMPTY)+(r?" props:"+_sanitizeDiagnosticText(n):STR_EMPTY);this[_DYN_MESSAGE]+=e}return e.dataType="MessageData",e}();function safeGetLogger(e,t){return(e||{})[_DYN_LOGGER]||new DiagnosticLogger(t)}var _a$2,_b,DiagnosticLogger=function(){function e(r){this.identifier="DiagnosticLogger",this.queue=[];var s,o,u,c,t,l=0,f={};dynamicProto(e,this,function(i){function a(e,t){var n,r;u<=l||(r=!0,n=AIInternalMessagePrefix+t[_DYN_MESSAGE_ID],f[n]?r=!1:f[n]=!0,r&&(e<=o&&(i.queue[_DYN_PUSH](t),l++,_(1===e?"error":"warn",t)),l===u&&(r=new _InternalLogMessage(23,n="Internal events throttle limit per PageView reached for this app.",!1),i.queue[_DYN_PUSH](r),1===e?i.errorToConsole(n):i[_DYN_WARN_TO_CONSOLE](n))))}function _(e,t){var n=getDebugExt(r||{});n&&n[_DYN_DIAG_LOG]&&n[_DYN_DIAG_LOG](e,t)}t=onConfigChange(createDynamicConfig(r||{},defaultValues$1,i).cfg,function(e){e=e.cfg;s=e[_DYN_LOGGING_LEVEL_CONSOL4],o=e.loggingLevelTelemetry,u=e.maxMessageLimit,c=e.enableDebug}),i.consoleLoggingLevel=function(){return s},i[_DYN_THROW_INTERNAL]=function(e,t,n,r,o){t=new _InternalLogMessage(t,n,o=void 0!==o&&o,r);if(c)throw dumpObj(t);n=_logFuncs[e]||STR_WARN_TO_CONSOLE;isUndefined(t[_DYN_MESSAGE])?_("throw"+(1===e?"Critical":"Warning"),t):(o?(r=+t[_DYN_MESSAGE_ID],!f[r]&&e<=s&&(i[n](t[_DYN_MESSAGE]),f[r]=!0)):e<=s&&i[n](t[_DYN_MESSAGE]),a(e,t))},i.debugToConsole=function(e){_logToConsole("debug",e),_("warning",e)},i[_DYN_WARN_TO_CONSOLE]=function(e){_logToConsole("warn",e),_("warning",e)},i.errorToConsole=function(e){_logToConsole("error",e),_("error",e)},i.resetInternalMessageCount=function(){l=0,f={}},i.logInternalMessage=a,i[_DYN_UNLOAD]=function(e){t&&t.rm(),t=null}})}return e.__ieDyn=1,e}();function _getLogger(e){return e||new DiagnosticLogger}function _throwInternal(e,t,n,r,o,i){void 0===i&&(i=!1),_getLogger(e)[_DYN_THROW_INTERNAL](t,n,r,o,i)}function _logInternalMessage(e,t,n){_getLogger(e).logInternalMessage(t,n)}var _doc,strToGMTString="toGMTString",strToUTCString="toUTCString",strCookie="cookie",strExpires="expires",strIsCookieUseDisabled="isCookieUseDisabled",strDisableCookiesUsage="disableCookiesUsage",strConfigCookieMgr="_ckMgr",_supportsCookies=null,_allowUaSameSite=null,_parsedCookieValue=null,_cookieCache={},_globalCookieConfig={},rootDefaultConfig=((_a$2={cookieCfg:cfgDfMerge(((_b={})[STR_DOMAIN]={fb:"cookieDomain",dfVal:isNotNullOrUndefined},_b.path={fb:"cookiePath",dfVal:isNotNullOrUndefined},_b.enabled=UNDEFINED_VALUE,_b.ignoreCookies=UNDEFINED_VALUE,_b.blockedCookies=UNDEFINED_VALUE,_b)),cookieDomain:UNDEFINED_VALUE,cookiePath:UNDEFINED_VALUE})[strDisableCookiesUsage]=UNDEFINED_VALUE,_a$2);function _getDoc(){_doc=_doc||getLazy(function(){return getDocument()})}function _gblCookieMgr(e,t){var n=createCookieMgr[strConfigCookieMgr]||_globalCookieConfig[strConfigCookieMgr];return n||(n=createCookieMgr[strConfigCookieMgr]=createCookieMgr(e,t),_globalCookieConfig[strConfigCookieMgr]=n),n}function _isMgrEnabled(e){return!e||e.isEnabled()}function _isIgnoredCookie(e,t){return!!(t&&e&&isArray(e.ignoreCookies))&&-1!==arrIndexOf(e.ignoreCookies,t)}function _isBlockedCookie(e,t){return!!(t&&e&&isArray(e.blockedCookies)&&-1!==arrIndexOf(e.blockedCookies,t))||_isIgnoredCookie(e,t)}function _isCfgEnabled(e,t){var n,t=t[_DYN_ENABLED];return isNullOrUndefined(t)&&(n=void 0,isUndefined(e[strIsCookieUseDisabled])||(n=!e[strIsCookieUseDisabled]),t=n=isUndefined(e[strDisableCookiesUsage])?n:!e[strDisableCookiesUsage]),t}function safeGetCookieMgr(e,t){var n,r;return e?r=e.getCookieMgr():t&&(r=(n=t.cookieCfg)&&n[strConfigCookieMgr]?n[strConfigCookieMgr]:createCookieMgr(t)),r||_gblCookieMgr(t,(e||{})[_DYN_LOGGER])}function createCookieMgr(n,o){var u,c,l,r,i,f,a,t=onConfigChange(n=createDynamicConfig(n||_globalCookieConfig,null,o).cfg,function(e){e.setDf(e.cfg,rootDefaultConfig),u=e.ref(e.cfg,"cookieCfg"),c=u[STR_PATH]||"/",l=u[STR_DOMAIN],r=!1!==_isCfgEnabled(n,u),i=u.getCookie||_getCookieValue,f=u.setCookie||_setCookieValue,a=u.delCookie||_setCookieValue},o),N={isEnabled:function(){var e=!1!==_isCfgEnabled(n,u)&&r&&areCookiesSupported(o),t=_globalCookieConfig[strConfigCookieMgr];return e&&t&&N!==t?_isMgrEnabled(t):e},setEnabled:function(e){r=!1!==e,u[_DYN_ENABLED]=e},set:function(e,t,n,r,o){var i,a,_,s=!1;return _isMgrEnabled(N)&&!_isBlockedCookie(u,e)&&(i={},a=strTrim(t||STR_EMPTY),-1!==(_=strIndexOf(a,";"))&&(a=strTrim(strLeft(t,_)),i=_extractParts(strSubstring(t,_+1))),setValue(i,STR_DOMAIN,r||l,isTruthy,isUndefined),isNullOrUndefined(n)||(t=isIE(),isUndefined(i[strExpires])&&0<(_=utcNow()+1e3*n)&&((r=new Date).setTime(_),setValue(i,strExpires,_formatDate(r,t?strToGMTString:strToUTCString)||_formatDate(r,t?strToGMTString:strToUTCString)||STR_EMPTY,isTruthy)),t||setValue(i,"max-age",STR_EMPTY+n,null,isUndefined)),(_=getLocation())&&"https:"===_.protocol&&(setValue(i,"secure",null,null,isUndefined),(_allowUaSameSite=null===_allowUaSameSite?!uaDisallowsSameSiteNone((getNavigator()||{})[_DYN_USER_AGENT]):_allowUaSameSite)&&setValue(i,"SameSite","None",null,isUndefined)),setValue(i,STR_PATH,o||c,null,isUndefined),f(e,_formatCookieValue(a,i)),s=!0),s},get:function(e){var t=STR_EMPTY;return _isMgrEnabled(N)&&!_isIgnoredCookie(u,e)?i(e):t},del:function(e,t){return!!_isMgrEnabled(N)&&N.purge(e,t)},purge:function(e,t){var n,r=!1;return areCookiesSupported(o)&&((n={})[STR_PATH]=t||"/",n[strExpires]="Thu, 01 Jan 1970 00:00:01 GMT",t=n,isIE()||(t["max-age"]="0"),a(e,_formatCookieValue(STR_EMPTY,t)),r=!0),r},unload:function(e){t&&t.rm(),t=null}};return N[strConfigCookieMgr]=N}function areCookiesSupported(e){if(null===_supportsCookies){_supportsCookies=!1,_doc||_getDoc();try{var t=_doc.v||{};_supportsCookies=t[strCookie]!==undefined}catch(n){_throwInternal(e,2,68,"Cannot access document.cookie - "+getExceptionName(n),{exception:dumpObj(n)})}}return _supportsCookies}function _extractParts(e){var n={};return e&&e[_DYN_LENGTH$1]&&arrForEach(strTrim(e)[_DYN_SPLIT](";"),function(e){var t;(e=strTrim(e||STR_EMPTY))&&(-1===(t=strIndexOf(e,"="))?n[e]=null:n[strTrim(strLeft(e,t))]=strTrim(strSubstring(e,t+1)))}),n}function _formatDate(e,t){return isFunction(e[t])?e[t]():null}function _formatCookieValue(e,t){var n=e||STR_EMPTY;return objForEachKey(t,function(e,t){n+="; "+e+(isNullOrUndefined(t)?STR_EMPTY:"="+t)}),n}function _getCookieValue(e){var t,n=STR_EMPTY;return _doc||_getDoc(),_doc.v&&(t=_doc.v[strCookie]||STR_EMPTY,_parsedCookieValue!==t&&(_cookieCache=_extractParts(t),_parsedCookieValue=t),n=strTrim(_cookieCache[e]||STR_EMPTY)),n}function _setCookieValue(e,t){_doc||_getDoc(),_doc.v&&(_doc.v[strCookie]=e+"="+t)}function uaDisallowsSameSiteNone(e){return!(!isString(e)||!strContains(e,"CPU iPhone OS 12")&&!strContains(e,"iPad; CPU OS 12")&&!(strContains(e,"Macintosh; Intel Mac OS X 10_14")&&strContains(e,"Version/")&&strContains(e,"Safari"))&&(!strContains(e,"Macintosh; Intel Mac OS X 10_14")||!strEndsWith(e,"AppleWebKit/605.1.15 (KHTML, like Gecko)"))&&!strContains(e,"Chrome/5")&&!strContains(e,"Chrome/6")&&(!strContains(e,"UnrealEngine")||strContains(e,"Chrome"))&&!strContains(e,"UCBrowser/12")&&!strContains(e,"UCBrowser/11"))}var strExecutionContextKey="ctx",strParentContextKey="ParentContextKey",strChildrenContextKey="ChildrenContextKey",PerfEvent=function(){function i(e,t,n){var r,o=this;o.start=utcNow(),o[_DYN_NAME$1]=e,o.isAsync=n,o[_DYN_IS_CHILD_EVT]=function(){return!1},isFunction(t)&&objDefine(o,"payload",{g:function(){return!r&&isFunction(t)&&(r=t(),t=null),r}}),o[_DYN_GET_CTX]=function(e){return e?(e===i[strParentContextKey]||e===i[strChildrenContextKey]?o:o[strExecutionContextKey]||{})[e]:null},o[_DYN_SET_CTX]=function(e,t){e&&(e===i[strParentContextKey]?(o[e]||(o[_DYN_IS_CHILD_EVT]=function(){return!0}),o[e]=t):e===i[strChildrenContextKey]?o[e]=t:(o[strExecutionContextKey]=o[strExecutionContextKey]||{})[e]=t)},o.complete=function(){var e=0,t=o[_DYN_GET_CTX](i[strChildrenContextKey]);if(isArray(t))for(var n=0;n<t[_DYN_LENGTH$1];n++){var r=t[n];r&&(e+=r.time)}o.time=utcNow()-o.start,o.exTime=o.time-e,o.complete=function(){}}}return i.ParentContextKey="parent",i.ChildrenContextKey="childEvts",i}(),doPerfActiveKey="CoreUtils.doPerf";function doPerf(e,t,n,r,o){if(e)if(e=e[STR_GET_PERF_MGR]?e[STR_GET_PERF_MGR]():e){var i,a=void 0,_=e[_DYN_GET_CTX](doPerfActiveKey);try{if(a=e.create(t(),r,o))return _&&a[_DYN_SET_CTX]&&(a[_DYN_SET_CTX](PerfEvent[strParentContextKey],_),_[_DYN_GET_CTX]&&_[_DYN_SET_CTX]&&((i=_[_DYN_GET_CTX](PerfEvent[strChildrenContextKey]))||(i=[],_[_DYN_SET_CTX](PerfEvent[strChildrenContextKey],i)),i[_DYN_PUSH](a))),e[_DYN_SET_CTX](doPerfActiveKey,a),n(a)}catch(s){a&&a[_DYN_SET_CTX]&&a[_DYN_SET_CTX]("exception",s)}finally{a&&e.fire(a),e[_DYN_SET_CTX](doPerfActiveKey,_)}}return n()}function generateW3CId(){for(var e,t=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"],n=STR_EMPTY,r=0;r<4;r++)n+=t[15&(e=random32())]+t[e>>4&15]+t[e>>8&15]+t[e>>12&15]+t[e>>16&15]+t[e>>20&15]+t[e>>24&15]+t[e>>28&15];var o=t[8+(3&random32())|0];return strSubstr(n,0,8)+strSubstr(n,9,4)+"4"+strSubstr(n,13,3)+o+strSubstr(n,16,3)+strSubstr(n,19,12)}var INVALID_TRACE_ID="00000000000000000000000000000000",INVALID_SPAN_ID="0000000000000000";function _isValid(e,t,n){return!(!e||e[_DYN_LENGTH$1]!==t||e===n||!e.match(/^[\da-f]*$/i))}function isValidTraceId(e){return _isValid(e,32,INVALID_TRACE_ID)}function isValidSpanId(e){return _isValid(e,16,INVALID_SPAN_ID)}var pluginStateData=createElmNodeData("plugin");function _getPluginState(e){return pluginStateData.get(e,"state",{},!0)}var _a$1,strTelemetryPluginChain="TelemetryPluginChain",strHasRunFlags="_hasRun",strGetTelCtx="_getTelCtx",_chainId=0;function _getNextProxyStart(e,t,n){for(;e;){if(e[_DYN_GET_PLUGIN]()===n)return e;e=e[_DYN_GET_NEXT]()}return createTelemetryProxyChain([n],t.config||{},t)}function _createInternalContext(e,i,n,t){var r=null,o=[],a=(i=i||createDynamicConfig({},null,n[_DYN_LOGGER]),null!==t&&(r=t?_getNextProxyStart(e,n,t):e),{_next:function(){var e,t=r;return r=t?t[_DYN_GET_NEXT]():null,t||(e=o)&&0<e[_DYN_LENGTH$1]&&(arrForEach(e,function(e){try{e.func.call(e.self,e.args)}catch(t){_throwInternal(n[_DYN_LOGGER],2,73,"Unexpected Exception during onComplete - "+dumpObj(t))}}),o=[]),t},ctx:{core:function(){return n},diagLog:function(){return safeGetLogger(n,i.cfg)},getCfg:function(){return i.cfg},getExtCfg:function(e,t){var r=_(e,!0);return t&&objForEachKey(t,function(e,t){var n;!isNullOrUndefined(r[e])||!(n=i.cfg[e])&&isNullOrUndefined(n)||(r[e]=n),_applyDefaultValue(i,r,e,t)}),i.setDf(r,t)},getConfig:function(e,t,n){void 0===n&&(n=!1);var r,e=_(e,!1),o=i.cfg;return!e||!e[t]&&isNullOrUndefined(e[t])?!o[t]&&isNullOrUndefined(o[t])||(r=o[t]):r=e[t],r||!isNullOrUndefined(r)?r:n},hasNext:function(){return!!r},getNext:function(){return r},setNext:function(e){r=e},iterate:function(e){for(;t=a._next();){var t=t[_DYN_GET_PLUGIN]();t&&e(t)}},onComplete:function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];e&&o[_DYN_PUSH]({func:e,self:isUndefined(t)?a.ctx:t,args:n})}}});function _(e,t){var n,r=null,o=i.cfg;return o&&e&&(n=o[STR_EXTENSION_CONFIG],o[STR_EXTENSION_CONFIG]=n=!n&&t?{}:n,(n=i.ref(o,STR_EXTENSION_CONFIG))&&(r=n[e],n[e]=r=!r&&t?{}:r,r=i.ref(n,e))),r}return a}function createProcessTelemetryContext(e,t,n,r){var o=createDynamicConfig(t),i=_createInternalContext(e,o,n,r),a=i.ctx;return a[_DYN_PROCESS_NEXT]=function(e){var t=i._next();return t&&t[STR_PROCESS_TELEMETRY](e,a),!t},a[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,o.cfg,n,t):e)||a[_DYN_GET_NEXT](),o.cfg,n,t)},a}function createProcessTelemetryUnloadContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t),i=o.ctx;return i[_DYN_PROCESS_NEXT]=function(e){var t=o._next();return t&&t[_DYN_UNLOAD](i,e),!t},i[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUnloadContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||i[_DYN_GET_NEXT](),n,t)},i}function createProcessTelemetryUpdateContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t).ctx;return o[_DYN_PROCESS_NEXT]=function(t){return o.iterate(function(e){isFunction(e[_DYN_UPDATE])&&e[_DYN_UPDATE](o,t)})},o[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUpdateContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||o[_DYN_GET_NEXT](),n,t)},o}function createTelemetryProxyChain(e,t,n,r){var o,i=null,a=!r;return isArray(e)&&0<e[_DYN_LENGTH$1]&&(o=null,arrForEach(e,function(e){(a=!a&&r===e||a)&&e&&isFunction(e[STR_PROCESS_TELEMETRY])&&(e=createTelemetryPluginProxy(e,t,n),i=i||e,o&&o._setNext(e),o=e)})),r&&!i?createTelemetryProxyChain([r],t,n):i}function createTelemetryPluginProxy(s,r,o){var u=null,i=isFunction(s[STR_PROCESS_TELEMETRY]),a=isFunction(s[_DYN_SET_NEXT_PLUGIN]),c=s?s[_DYN_IDENTIFIER]+"-"+s[STR_PRIORITY]+"-"+_chainId++:"Unknown-0-"+_chainId++,_={getPlugin:function(){return s},getNext:function(){return u},processTelemetry:function(n,e){var t;l(e=e||(t=(t=s&&isFunction(s[strGetTelCtx])?s[strGetTelCtx]():t)||createProcessTelemetryContext(_,r,o)),function(e){if(!s||!i)return!1;var t=_getPluginState(s);return!t[_DYN_TEARDOWN]&&!t[STR_DISABLED]&&(a&&s[_DYN_SET_NEXT_PLUGIN](u),s[STR_PROCESS_TELEMETRY](n,e),!0)},"processTelemetry",function(){return{item:n}},!n.sync)||e[_DYN_PROCESS_NEXT](n)},unload:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||(e[STR_CORE]=null,e[_DYN_TEARDOWN]=!0,e[_DYN_IS_INITIALIZED]=!1,s[_DYN_TEARDOWN]&&!0===s[_DYN_TEARDOWN](r,o)&&(n=!0))),n},"unload",function(){},o.isAsync)||r[_DYN_PROCESS_NEXT](o)},update:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||s[_DYN_UPDATE]&&!0===s[_DYN_UPDATE](r,o)&&(n=!0)),n},"update",function(){},!1)||r[_DYN_PROCESS_NEXT](o)},_id:c,_setNext:function(e){u=e}};function l(n,r,o,e,t){var i=!1,a=s?s[_DYN_IDENTIFIER]:strTelemetryPluginChain,_=(_=n[strHasRunFlags])||(n[strHasRunFlags]={});return n.setNext(u),s&&doPerf(n[STR_CORE](),function(){return a+":"+o},function(){_[c]=!0;try{var e=u?u._id:STR_EMPTY;e&&(_[e]=!1),i=r(n)}catch(t){e=!u||_[u._id];e&&(i=!0),u&&e||_throwInternal(n[_DYN_DIAG_LOG](),1,73,"Plugin ["+a+"] failed during "+o+" - "+dumpObj(t)+", run flags: "+dumpObj(_))}},e,t),i}return objFreeze(_)}function createUnloadHandlerContainer(){var t=[];return{add:function(e){e&&t[_DYN_PUSH](e)},run:function(n,r){arrForEach(t,function(e){try{e(n,r)}catch(t){_throwInternal(n[_DYN_DIAG_LOG](),2,73,"Unexpected error calling unload handler - "+dumpObj(t))}}),t=[]}}}function createUnloadHookContainer(){var t=[];return{run:function(n){var e=t;t=[],arrForEach(e,function(e){try{(e.rm||e.remove).call(e)}catch(t){_throwInternal(n,2,73,"Unloading:"+dumpObj(t))}})},add:function(e){e&&arrAppend(t,e)}}}var strGetPlugin="getPlugin",defaultValues=((_a$1={})[STR_EXTENSION_CONFIG]={isVal:isNotNullOrUndefined,v:{}},_a$1),BaseTelemetryPlugin=function(){function e(){var o,i,u,c,l,a=this;function t(e){var t,e=e=void 0===e?null:e;return e||(t=i||createProcessTelemetryContext(null,{},a[STR_CORE]),e=u&&u[strGetPlugin]?t[_DYN_CREATE_NEW](null,u[strGetPlugin]):t[_DYN_CREATE_NEW](null,u)),e}function _(e,t,n){createDynamicConfig(e,defaultValues,safeGetLogger(t)),!n&&t&&(n=t[_DYN_GET_PROCESS_TEL_CONT2]()[_DYN_GET_NEXT]());var r=u;u&&u[strGetPlugin]&&(r=u[strGetPlugin]()),a[STR_CORE]=t,i=createProcessTelemetryContext(n,e,t,r)}function f(){o=!1,a[STR_CORE]=null,u=i=null,l=createUnloadHookContainer(),c=createUnloadHandlerContainer()}f(),dynamicProto(e,a,function(s){s[_DYN_INITIALIZE]=function(e,t,n,r){_(e,t,r),o=!0},s[_DYN_TEARDOWN]=function(e,t){var n,r,o,i,a=s[STR_CORE];if(a&&(!e||a===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUnloadContext(null,a,u&&u[strGetPlugin]?u[strGetPlugin]():u),i=t||{reason:0,isAsync:!1},s[_DYN__DO_TEARDOWN]&&!0===s[_DYN__DO_TEARDOWN](o,i,_)?n=!0:_(),n;function _(){r||(r=!0,c.run(o,t),l.run(o[_DYN_DIAG_LOG]()),!0===n&&o[_DYN_PROCESS_NEXT](i),f())}},s[_DYN_UPDATE]=function(e,t){var n,r,o,i=s[STR_CORE];if(i&&(!e||i===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUpdateContext(null,i,u&&u[strGetPlugin]?u[strGetPlugin]():u),s._doUpdate&&!0===s._doUpdate(o,t||{reason:0},a)?n=!0:a(),n;function a(){r||(r=!0,_(o.getCfg(),o.core(),o[_DYN_GET_NEXT]()))}},proxyFunctionAs(s,"_addUnloadCb",function(){return c},"add"),proxyFunctionAs(s,"_addHook",function(){return l},"add"),objDefine(s,"_unloadHooks",{g:function(){return l}})}),a[_DYN_DIAG_LOG]=function(e){return t(e)[_DYN_DIAG_LOG]()},a[_DYN_IS_INITIALIZED]=function(){return o},a.setInitialized=function(e){o=e},a[_DYN_SET_NEXT_PLUGIN]=function(e){u=e},a[_DYN_PROCESS_NEXT]=function(e,t){t?t[_DYN_PROCESS_NEXT](e):u&&isFunction(u[STR_PROCESS_TELEMETRY])&&u[STR_PROCESS_TELEMETRY](e,null)},a._getTelCtx=t}return e.__ieDyn=1,e}(),strNotSpecified="not_specified",_DYN_LENGTH="length",_DYN_TO_STRING="toString",_DYN_REMOVE_ITEM="removeItem",_DYN_STRINGIFY="stringify",_DYN_NAME="name",_DYN_PROPERTIES="properties",_DYN_MEASUREMENTS="measurements",_DYN_DURATION="duration";function dataSanitizeKeyAndAddUniqueness(e,t,n){var r=t[_DYN_LENGTH],o=dataSanitizeKey(e,t);if(o[_DYN_LENGTH]!==r){for(var i=0,a=o;n[a]!==undefined;)i++,a=strSubstring(o,0,147)+dsPadNumber(i);o=a}return o}function dataSanitizeKey(e,t){var n;return t&&150<(t=strTrim(asString(t)))[_DYN_LENGTH]&&(n=strSubstring(t,0,150),_throwInternal(e,2,57,"name is too long.  It has been truncated to 150 characters.",{name:t},!0)),n||t}function dataSanitizeString(e,t,n){var r;return void 0===n&&(n=1024),t&&(n=n||1024,(t=strTrim(asString(t)))[_DYN_LENGTH]>n&&(r=strSubstring(t,0,n),_throwInternal(e,2,61,"string value is too long. It has been truncated to "+n+" characters.",{value:t},!0))),r||t}function dataSanitizeUrl(e,t){return dataSanitizeInput(e,t,2048,66)}function dataSanitizeProperties(r,e){var o;return e&&(o={},objForEachKey(e,function(e,t){if(isObject(t)&&hasJSON())try{t=getJSON()[_DYN_STRINGIFY](t)}catch(n){_throwInternal(r,2,49,"custom property is not valid",{exception:n},!0)}t=dataSanitizeString(r,t,8192),e=dataSanitizeKeyAndAddUniqueness(r,e,o),o[e]=t}),e=o),e}function dataSanitizeMeasurements(n,e){var r;return e&&(r={},objForEachKey(e,function(e,t){e=dataSanitizeKeyAndAddUniqueness(n,e,r),r[e]=t}),e=r),e}function dataSanitizeId(e,t){return t&&dataSanitizeInput(e,t,128,69)[_DYN_TO_STRING]()}function dataSanitizeInput(e,t,n,r){var o;return t&&(t=strTrim(asString(t)))[_DYN_LENGTH]>n&&(o=strSubstring(t,0,n),_throwInternal(e,2,r,"input is too long, it has been truncated to "+n+" characters.",{data:t},!0)),o||t}function dsPadNumber(e){e="00"+e;return strSubstr(e,e[_DYN_LENGTH]-3)}function createDistributedTraceContextFromTrace(e,t){var n=e||{};return{getName:function(){return n[_DYN_NAME]},setName:function(e){t&&t.setName(e),n[_DYN_NAME]=e},getTraceId:function(){return n.traceID},setTraceId:function(e){t&&t.setTraceId(e),isValidTraceId(e)&&(n.traceID=e)},getSpanId:function(){return n.parentID},setSpanId:function(e){t&&t.setSpanId(e),isValidSpanId(e)&&(n.parentID=e)},getTraceFlags:function(){return n.traceFlags},setTraceFlags:function(e){t&&t.setTraceFlags(e),n.traceFlags=e}}}var StorageType=createEnumStyle({LocalStorage:0,SessionStorage:1}),_canUseLocalStorage=undefined,_storagePrefix="";function _getLocalStorageObject(){return utlCanUseLocalStorage()?_getVerifiedStorageObject(StorageType.LocalStorage):null}function _getVerifiedStorageObject(e){try{if(isNullOrUndefined(getGlobal()))return null;var t=(new Date)[_DYN_TO_STRING](),n=getInst(e===StorageType.LocalStorage?"localStorage":"sessionStorage"),r=_storagePrefix+t,o=(n.setItem(r,t),n.getItem(r)!==t);if(n[_DYN_REMOVE_ITEM](r),!o)return n}catch(i){}return null}function utlSetStoragePrefix(e){_storagePrefix=e||""}function utlCanUseLocalStorage(e){return _canUseLocalStorage=e||_canUseLocalStorage===undefined?!!_getVerifiedStorageObject(StorageType.LocalStorage):_canUseLocalStorage}function utlGetLocalStorage(e,t){var n=_getLocalStorageObject();if(null!==n)try{return n.getItem(t)}catch(r){_canUseLocalStorage=!1,_throwInternal(e,2,1,"Browser failed read of local storage. "+getExceptionName(r),{exception:dumpObj(r)})}return null}function utlSetLocalStorage(e,t,n){var r=_getLocalStorageObject();if(null!==r)try{return r.setItem(t,n),!0}catch(o){_canUseLocalStorage=!1,_throwInternal(e,2,3,"Browser failed write to local storage. "+getExceptionName(o),{exception:dumpObj(o)})}return!1}function utlRemoveStorage(e,t){var n=_getLocalStorageObject();if(null!==n)try{return n[_DYN_REMOVE_ITEM](t),!0}catch(r){_canUseLocalStorage=!1,_throwInternal(e,2,5,"Browser failed removal of local storage item. "+getExceptionName(r),{exception:dumpObj(r)})}return!1}var strEmpty="";function msToTimeSpan(e){e=mathRound(e=isNaN(e)||e<0?0:e);var t=strEmpty+e%1e3,n=strEmpty+mathFloor(e/1e3)%60,r=strEmpty+mathFloor(e/6e4)%60,o=strEmpty+mathFloor(e/36e5)%24,e=mathFloor(e/864e5),t=1===t[_DYN_LENGTH]?"00"+t:2===t[_DYN_LENGTH]?"0"+t:t,n=n[_DYN_LENGTH]<2?"0"+n:n,r=r[_DYN_LENGTH]<2?"0"+r:r,o=o[_DYN_LENGTH]<2?"0"+o:o;return(0<e?e+".":strEmpty)+o+":"+r+":"+n+"."+t}var PageView=function(){function e(e,t,n,r,o,i,a){this.aiDataContract={ver:1,name:0,url:0,duration:0,properties:0,measurements:0,id:0};var _=this;_.ver=2,_.id=dataSanitizeId(e,a),_.url=dataSanitizeUrl(e,n),_[_DYN_NAME]=dataSanitizeString(e,t)||strNotSpecified,isNaN(r)||(_[_DYN_DURATION]=msToTimeSpan(r)),_[_DYN_PROPERTIES]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,i)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Pageview",e.dataType="PageviewData",e}();function _aiNameFunc(e){var t="ai."+e+".";return function(e){return t+e}}var _aiApplication=_aiNameFunc("application"),_aiDevice=_aiNameFunc("device"),_aiLocation=_aiNameFunc("location"),_aiOperation=_aiNameFunc("operation"),_aiSession=_aiNameFunc("session"),_aiUser=_aiNameFunc("user"),_aiCloud=_aiNameFunc("cloud"),_aiInternal=_aiNameFunc("internal"),ContextTagKeys=function(e){function t(){return e.call(this)||this}return __extendsFn(t,e),t}(createClassFromInterface({applicationVersion:_aiApplication("ver"),applicationBuild:_aiApplication("build"),applicationTypeId:_aiApplication("typeId"),applicationId:_aiApplication("applicationId"),applicationLayer:_aiApplication("layer"),deviceId:_aiDevice("id"),deviceIp:_aiDevice("ip"),deviceLanguage:_aiDevice("language"),deviceLocale:_aiDevice("locale"),deviceModel:_aiDevice("model"),deviceFriendlyName:_aiDevice("friendlyName"),deviceNetwork:_aiDevice("network"),deviceNetworkName:_aiDevice("networkName"),deviceOEMName:_aiDevice("oemName"),deviceOS:_aiDevice("os"),deviceOSVersion:_aiDevice("osVersion"),deviceRoleInstance:_aiDevice("roleInstance"),deviceRoleName:_aiDevice("roleName"),deviceScreenResolution:_aiDevice("screenResolution"),deviceType:_aiDevice("type"),deviceMachineName:_aiDevice("machineName"),deviceVMName:_aiDevice("vmName"),deviceBrowser:_aiDevice("browser"),deviceBrowserVersion:_aiDevice("browserVersion"),locationIp:_aiLocation("ip"),locationCountry:_aiLocation("country"),locationProvince:_aiLocation("province"),locationCity:_aiLocation("city"),operationId:_aiOperation("id"),operationName:_aiOperation("name"),operationParentId:_aiOperation("parentId"),operationRootId:_aiOperation("rootId"),operationSyntheticSource:_aiOperation("syntheticSource"),operationCorrelationVector:_aiOperation("correlationVector"),sessionId:_aiSession("id"),sessionIsFirst:_aiSession("isFirst"),sessionIsNew:_aiSession("isNew"),userAccountAcquisitionDate:_aiUser("accountAcquisitionDate"),userAccountId:_aiUser("accountId"),userAgent:_aiUser("userAgent"),userId:_aiUser("id"),userStoreRegion:_aiUser("storeRegion"),userAuthUserId:_aiUser("authUserId"),userAnonymousUserAcquisitionDate:_aiUser("anonUserAcquisitionDate"),userAuthenticatedUserAcquisitionDate:_aiUser("authUserAcquisitionDate"),cloudName:_aiCloud("name"),cloudRole:_aiCloud("role"),cloudRoleVer:_aiCloud("roleVer"),cloudRoleInstance:_aiCloud("roleInstance"),cloudEnvironment:_aiCloud("environment"),cloudLocation:_aiCloud("location"),cloudDeploymentUnit:_aiCloud("deploymentUnit"),internalNodeName:_aiInternal("nodeName"),internalSdkVersion:_aiInternal("sdkVersion"),internalAgentVersion:_aiInternal("agentVersion"),internalSnippet:_aiInternal("snippet"),internalSdkSrc:_aiInternal("sdkSrc")})),Extensions={UserExt:"user",DeviceExt:"device",TraceExt:"trace",WebExt:"web",AppExt:"app",OSExt:"os",SessionExt:"ses",SDKExt:"sdk"},CtxTagKeys=new ContextTagKeys,PropertiesPluginIdentifier="AppInsightsPropertiesPlugin",BreezeChannelIdentifier="AppInsightsChannelPlugin",Application=function(){},Device=function(){this.id="browser",this.deviceClass="Browser"},Version="3.3.8",Internal=function(t,e){var n=this,r=onConfigChange(t,function(){var e=t.sdkExtension;n.sdkVersion=(e?e+"_":"")+"javascript:"+Version});e&&e.add(r)},Location=function(){},_DYN_SESSION="session",_DYN_SESSION_MANAGER="sessionManager",_DYN_IS_USER_COOKIE_SET="isUserCookieSet",_DYN_IS_NEW_USER="isNewUser",_DYN_GET_TRACE_CTX="getTraceCtx",_DYN_TELEMETRY_TRACE="telemetryTrace",_DYN_APPLY_SESSION_CONTEX0="applySessionContext",_DYN_APPLY_APPLICATION_CO1="applyApplicationContext",_DYN_APPLY_OPERATION_CONT2="applyOperationContext",_DYN_APPLY_OPERATING_SYST3="applyOperatingSystemContxt",_DYN_APPLY_LOCATION_CONTE4="applyLocationContext",_DYN_APPLY_INTERNAL_CONTE5="applyInternalContext",_DYN_GET_SESSION_ID="getSessionId",_DYN_SESSION_COOKIE_POSTF6="sessionCookiePostfix",_DYN_AUTOMATIC_SESSION="automaticSession",_DYN_ACCOUNT_ID="accountId",_DYN_AUTHENTICATED_ID="authenticatedId",_DYN_ACQUISITION_DATE="acquisitionDate",_DYN_RENEWAL_DATE="renewalDate",_DYN_COOKIE_SEPARATOR="cookieSeparator",_DYN_AUTH_USER_COOKIE_NAM7="authUserCookieName",SESSION_COOKIE_NAME="ai_session",ACQUISITION_SPAN=864e5,RENEWAL_SPAN=18e5,COOKIE_UPDATE_INTERVAL=6e4,Session=function(){},_SessionManager=function(){function n(u,e,t){var c,l,f,N,E=safeGetLogger(e),g=safeGetCookieMgr(e);dynamicProto(n,this,function(a){var e=onConfigChange(u=u||{},function(e){f=u.sessionExpirationMs||ACQUISITION_SPAN,N=u.sessionRenewalMs||RENEWAL_SPAN;var t=u[_DYN_SESSION_COOKIE_POSTF6]||u.namePrefix||"";c=SESSION_COOKIE_NAME+t});function _(e,t){var n=!1,r=", session will be reset",o=t.split("|");if(2<=o.length)try{var i=+o[1]||0,a=+o[2]||0;isNaN(i)||i<=0?_throwInternal(E,2,27,"AI session acquisition date is 0"+r):isNaN(a)||a<=0?_throwInternal(E,2,27,"AI session renewal date is 0"+r):o[0]&&(e.id=o[0],e[_DYN_ACQUISITION_DATE]=i,e[_DYN_RENEWAL_DATE]=a,n=!0)}catch(_){_throwInternal(E,1,9,"Error parsing ai_session value ["+(t||"")+"]"+r+" - "+getExceptionName(_),{exception:dumpObj(_)})}return n}function s(e,t){var n=e[_DYN_ACQUISITION_DATE],r=(e[_DYN_RENEWAL_DATE]=t,N),o=n+f-t,e=[e.id,n,t],n=o<r?o/1e3:r/1e3,o=u.cookieDomain||null;g.set(c,e.join("|"),0<f?n:null,o),l=t}t&&t.add(e),a[_DYN_AUTOMATIC_SESSION]=new Session,a.update=function(){var e,t,n,r=utcNow(),o=!1,i=a[_DYN_AUTOMATIC_SESSION];!(o=i.id?o:(e=i,t=!1,(n=g.get(c))&&isFunction(n.split)?t=_(e,n):(n=utlGetLocalStorage(E,c))&&(t=_(e,n)),!(t||e.id)))&&0<f&&(n=r-i[_DYN_ACQUISITION_DATE],t=r-i[_DYN_RENEWAL_DATE],o=(o=(o=n<0||t<0)||f<n)||N<t),o?(e=r,n=u.getNewId||newId,a[_DYN_AUTOMATIC_SESSION].id=n(u.idLength||22),a[_DYN_AUTOMATIC_SESSION][_DYN_ACQUISITION_DATE]=e,s(a[_DYN_AUTOMATIC_SESSION],e),utlCanUseLocalStorage()||_throwInternal(E,2,0,"Browser does not support local storage. Session durations will be inaccurate.")):(!l||COOKIE_UPDATE_INTERVAL<r-l)&&s(i,r)},a.backup=function(){var e=a[_DYN_AUTOMATIC_SESSION],t=e.id,n=e[_DYN_ACQUISITION_DATE],e=e[_DYN_RENEWAL_DATE];utlSetLocalStorage(E,c,[t,n,e].join("|"))}})}return n.__ieDyn=1,n}(),TelemetryTrace=function(e,t,n,r){this.traceID=e||generateW3CId(),this.parentID=t;e=getLocation();!n&&e&&e.pathname&&(n=e.pathname),this.name=dataSanitizeString(r,n)};function _validateUserInput(e){return!("string"!=typeof e||!e||e.match(/,|;|=| |\|/))}var User=function(){function c(i,e,a){this.isNewUser=!1,this.isUserCookieSet=!1;var _,s=safeGetLogger(e),u=safeGetCookieMgr(e);dynamicProto(c,this,function(r){objDefine(r,"config",{g:function(){return i}});var e=onConfigChange(i,function(){var e=i.userCookiePostfix||"",e=(_=c.userCookieName+e,u.get(_)),e=(e&&(r[_DYN_IS_NEW_USER]=!1,0<(e=e.split(c[_DYN_COOKIE_SEPARATOR])).length&&(r.id=e[0],r[_DYN_IS_USER_COOKIE_SET]=!!r.id)),r.id||(r.id=t(),o(n(r.id).join(c[_DYN_COOKIE_SEPARATOR])),e=(i.namePrefix||"")+"ai_session",utlRemoveStorage(s,e)),r[_DYN_ACCOUNT_ID]=i[_DYN_ACCOUNT_ID]||undefined,u.get(c[_DYN_AUTH_USER_COOKIE_NAM7]));e&&((e=(e=decodeURI(e)).split(c[_DYN_COOKIE_SEPARATOR]))[0]&&(r[_DYN_AUTHENTICATED_ID]=e[0]),1<e.length&&e[1]&&(r[_DYN_ACCOUNT_ID]=e[1]))});function t(){var e=i||{};return(e.getNewId||newId)(e.idLength?i.idLength:22)}function n(e){var t=toISOString(new Date);return r.accountAcquisitionDate=t,r[_DYN_IS_NEW_USER]=!0,[e,t]}function o(e){r[_DYN_IS_USER_COOKIE_SET]=u.set(_,e,31536e3)}a&&a.add(e),r.setAuthenticatedUserContext=function(e,t,n){void 0===n&&(n=!1),!_validateUserInput(e)||t&&!_validateUserInput(t)?_throwInternal(s,2,60,"Setting auth user context failed. User auth/account id should be of type string, and not contain commas, semi-colons, equal signs, spaces, or vertical-bars.",!0):(r[_DYN_AUTHENTICATED_ID]=e,e=r[_DYN_AUTHENTICATED_ID],t&&(r[_DYN_ACCOUNT_ID]=t,e=[r[_DYN_AUTHENTICATED_ID],r.accountId].join(c[_DYN_COOKIE_SEPARATOR])),n&&u.set(c[_DYN_AUTH_USER_COOKIE_NAM7],encodeURI(e)))},r.clearAuthenticatedUserContext=function(){r[_DYN_AUTHENTICATED_ID]=null,r[_DYN_ACCOUNT_ID]=null,u.del(c[_DYN_AUTH_USER_COOKIE_NAM7])},r.update=function(e){r.id===e&&r[_DYN_IS_USER_COOKIE_SET]||o(n(e||t()).join(c[_DYN_COOKIE_SEPARATOR]))}})}return c.cookieSeparator="|",c.userCookieName="ai_user",c.authUserCookieName="ai_authUser",c}(),strExt="ext",strTags="tags";function _removeEmpty(e,t){e&&e[t]&&0===objKeys(e[t]).length&&delete e[t]}function _nullResult(){return null}var _a,undefString,TelemetryContext=function(){function e(r,i,a,_){var s=this,u=r.logger;dynamicProto(e,this,function(o){var e,t,n;o.appId=_nullResult,o[_DYN_GET_SESSION_ID]=_nullResult,o.application=new Application,o.internal=new Internal(i,_),hasWindow()&&(o[_DYN_SESSION_MANAGER]=new _SessionManager(i,r,_),o.device=new Device,o.location=new Location,o.user=new User(i,r,_),t=e=void 0,a&&(e=a.getTraceId(),t=a.getSpanId(),n=a.getName()),o[_DYN_TELEMETRY_TRACE]=new TelemetryTrace(e,t,n,u),o[_DYN_SESSION]=new Session),o[_DYN_GET_SESSION_ID]=function(){var e=o[_DYN_SESSION];return e&&isString(e.id)?e.id:(e=(o[_DYN_SESSION_MANAGER]||{})[_DYN_AUTOMATIC_SESSION])&&isString(e.id)?e.id:null},o[_DYN_APPLY_SESSION_CONTEX0]=function(e,t){setValue(getSetValue(e.ext,Extensions.AppExt),"sesId",o[_DYN_GET_SESSION_ID](),isString)},o[_DYN_APPLY_OPERATING_SYST3]=function(e,t){setValue(e.ext,Extensions.OSExt,o.os)},o[_DYN_APPLY_APPLICATION_CO1]=function(e,t){var n=o.application;n&&(setValue(e=getSetValue(e,strTags),CtxTagKeys.applicationVersion,n.ver,isString),setValue(e,CtxTagKeys.applicationBuild,n.build,isString))},o.applyDeviceContext=function(e,t){var n=o.device;n&&(setValue(e=getSetValue(getSetValue(e,strExt),Extensions.DeviceExt),"localId",n.id,isString),setValue(e,"ip",n.ip,isString),setValue(e,"model",n.model,isString),setValue(e,"deviceClass",n.deviceClass,isString))},o[_DYN_APPLY_INTERNAL_CONTE5]=function(e,t){var n,r=o.internal;r&&(setValue(n=getSetValue(e,strTags),CtxTagKeys.internalAgentVersion,r.agentVersion,isString),setValue(n,CtxTagKeys.internalSdkVersion,dataSanitizeString(u,r.sdkVersion,64),isString),e.baseType!==_InternalLogMessage.dataType&&e.baseType!==PageView.dataType||(setValue(n,CtxTagKeys.internalSnippet,r.snippetVer,isString),setValue(n,CtxTagKeys.internalSdkSrc,r.sdkSrc,isString)))},o[_DYN_APPLY_LOCATION_CONTE4]=function(e,t){var n=s.location;n&&setValue(getSetValue(e,strTags,[]),CtxTagKeys.locationIp,n.ip,isString)},o[_DYN_APPLY_OPERATION_CONT2]=function(e,t){var n=o[_DYN_TELEMETRY_TRACE];n&&(setValue(e=getSetValue(getSetValue(e,strExt),Extensions.TraceExt,{traceID:undefined,parentID:undefined}),"traceID",n.traceID,isString,isNullOrUndefined),setValue(e,"name",n.name,isString,isNullOrUndefined),setValue(e,"parentID",n.parentID,isString,isNullOrUndefined))},o.applyWebContext=function(e,t){var n=s.web;n&&setValue(getSetValue(e,strExt),Extensions.WebExt,n)},o.applyUserContext=function(e,t){var n=o.user;n&&(setValue(getSetValue(e,strTags,[]),CtxTagKeys.userAccountId,n[_DYN_ACCOUNT_ID],isString),setValue(e=getSetValue(getSetValue(e,strExt),Extensions.UserExt),"id",n.id,isString),setValue(e,"authId",n[_DYN_AUTHENTICATED_ID],isString))},o.cleanUp=function(e,t){e=e.ext;e&&(_removeEmpty(e,Extensions.DeviceExt),_removeEmpty(e,Extensions.UserExt),_removeEmpty(e,Extensions.WebExt),_removeEmpty(e,Extensions.OSExt),_removeEmpty(e,Extensions.AppExt),_removeEmpty(e,Extensions.TraceExt))}})}return e.__ieDyn=1,e}(),nullValue=null,_defaultConfig=objDeepFreeze(((_a={accountId:nullValue,sessionRenewalMs:18e5,samplingPercentage:100,sessionExpirationMs:864e5,cookieDomain:nullValue,sdkExtension:nullValue,isBrowserLinkTrackingEnabled:!1,appId:nullValue})[_DYN_GET_SESSION_ID]=nullValue,_a.namePrefix=undefString,_a[_DYN_SESSION_COOKIE_POSTF6]=undefString,_a.userCookiePostfix=undefString,_a.idLength=22,_a.getNewId=nullValue,_a)),PropertiesPlugin=function(t){function n(){var u,c,l,f,N,e=t.call(this)||this;return e.priority=110,e.identifier=PropertiesPluginIdentifier,dynamicProto(n,e,function(_,s){function n(){N=!(f=l=c=u=null)}n(),objDefine(_,"context",{g:function(){return f}}),_.initialize=function(e,t,n,r){var o,i,a;s.initialize(e,t,n,r),i=_.identifier,a=_.core,_._addHook(onConfigChange(o=e,function(){var e=createProcessTelemetryContext(null,o,a);o.storagePrefix&&utlSetStoragePrefix(o.storagePrefix),N=!1!==o.disableUserInitMessage,u=e.getExtCfg(i,_defaultConfig),_._extConfig=u})),l=a[_DYN_GET_TRACE_CTX](!1),f=new TelemetryContext(a,u,l,_._unloadHooks),c=createDistributedTraceContextFromTrace(_.context[_DYN_TELEMETRY_TRACE],l),a.setTraceCtx(c),_.context.appId=function(){var e=a.getPlugin(BreezeChannelIdentifier);return e?e.plugin._appId:null}},_.processTelemetry=function(e,t){var n,r,o,i;isNullOrUndefined(e)||(t=_._getTelCtx(t),e.name===PageView.envelopeType&&t.diagLog().resetInternalMessageCount(),(o=f||{})[_DYN_SESSION]&&"string"!=typeof f[_DYN_SESSION].id&&o[_DYN_SESSION_MANAGER]&&o[_DYN_SESSION_MANAGER].update(),(n=o.user)&&!n[_DYN_IS_USER_COOKIE_SET]&&n.update(o.user.id),o=t,getSetValue(r=e,"tags",[]),getSetValue(r,"ext",{}),(i=_.context)[_DYN_APPLY_SESSION_CONTEX0](r,o),i[_DYN_APPLY_APPLICATION_CO1](r,o),i.applyDeviceContext(r,o),i[_DYN_APPLY_OPERATION_CONT2](r,o),i.applyUserContext(r,o),i[_DYN_APPLY_OPERATING_SYST3](r,o),i.applyWebContext(r,o),i[_DYN_APPLY_LOCATION_CONTE4](r,o),i[_DYN_APPLY_INTERNAL_CONTE5](r,o),i.cleanUp(r,o),n&&n[_DYN_IS_NEW_USER]&&(n[_DYN_IS_NEW_USER]=!1,N||(r=new _InternalLogMessage(72,(getNavigator()||{}).userAgent||""),_logInternalMessage(t.diagLog(),1,r))),_.processNext(e,t))},_._doTeardown=function(e,t){e=(e||{}).core();e&&e[_DYN_GET_TRACE_CTX]&&e[_DYN_GET_TRACE_CTX](!1)===c&&e.setTraceCtx(l),n()}}),e}return __extendsFn(n,t),n.__ieDyn=1,n}(BaseTelemetryPlugin),PropertiesPlugin$1=PropertiesPlugin;exports.PropertiesPlugin=PropertiesPlugin$1,exports.Session=Session,exports.SessionManager=_SessionManager,exports.TelemetryContext=TelemetryContext,exports.TelemetryTrace=TelemetryTrace;
//# sourceMappingURL=ai.props.3.cjs.min.js.map
